Index: drivers/acpi/utilities/utxface.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/acpi/utilities/utxface.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/acpi/utilities/utxface.c	22 Jul 2004 19:49:49 -0000	1.1
+++ drivers/acpi/utilities/utxface.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -1,46 +1,61 @@
 /******************************************************************************
  *
  * Module Name: utxface - External interfaces for "global" ACPI functions
- *              $Revision: 1.1 $
  *
  *****************************************************************************/
 
 /*
- *  Copyright (C) 2000, 2001 R. Byron Moore
+ * Copyright (C) 2000 - 2004, R. Byron Moore
+ * All rights reserved.
  *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions, and the following disclaimer,
+ *    without modification.
+ * 2. Redistributions in binary form must reproduce at minimum a disclaimer
+ *    substantially similar to the "NO WARRANTY" disclaimer below
+ *    ("Disclaimer") and any redistribution must be conditioned upon
+ *    including a substantially similar Disclaimer requirement for further
+ *    binary redistribution.
+ * 3. Neither the names of the above-listed copyright holders nor the names
+ *    of any contributors may be used to endorse or promote products derived
+ *    from this software without specific prior written permission.
+ *
+ * Alternatively, this software may be distributed under the terms of the
+ * GNU General Public License ("GPL") version 2 as published by the Free
+ * Software Foundation.
+ *
+ * NO WARRANTY
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ * HOLDERS OR CONTRIBUTORS BE LIABLE FOR SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGES.
  */
 
 
-#include "acpi.h"
-#include "acevents.h"
-#include "achware.h"
-#include "acnamesp.h"
-#include "acinterp.h"
-#include "amlcode.h"
-#include "acdebug.h"
-#include "acexcep.h"
-
+#include <acpi/acpi.h>
+#include <acpi/acevents.h>
+#include <acpi/acnamesp.h>
+#include <acpi/acparser.h>
+#include <acpi/acdispat.h>
+#include <acpi/acdebug.h>
 
 #define _COMPONENT          ACPI_UTILITIES
-	 MODULE_NAME         ("utxface")
+	 ACPI_MODULE_NAME    ("utxface")
 
 
 /*******************************************************************************
  *
- * FUNCTION:    Acpi_initialize_subsystem
+ * FUNCTION:    acpi_initialize_subsystem
  *
  * PARAMETERS:  None
  *
@@ -55,12 +70,12 @@
 acpi_initialize_subsystem (
 	void)
 {
-	acpi_status             status;
+	acpi_status                     status;
 
-	FUNCTION_TRACE ("Acpi_initialize_subsystem");
+	ACPI_FUNCTION_TRACE ("acpi_initialize_subsystem");
 
 
-	DEBUG_EXEC(acpi_ut_init_stack_ptr_trace ());
+	ACPI_DEBUG_EXEC (acpi_ut_init_stack_ptr_trace ());
 
 
 	/* Initialize all globals used by the subsystem */
@@ -71,7 +86,7 @@
 
 	status = acpi_os_initialize ();
 	if (ACPI_FAILURE (status)) {
-		REPORT_ERROR (("OSD failed to initialize, %s\n",
+		ACPI_REPORT_ERROR (("OSD failed to initialize, %s\n",
 			acpi_format_exception (status)));
 		return_ACPI_STATUS (status);
 	}
@@ -80,7 +95,7 @@
 
 	status = acpi_ut_mutex_initialize ();
 	if (ACPI_FAILURE (status)) {
-		REPORT_ERROR (("Global mutex creation failure, %s\n",
+		ACPI_REPORT_ERROR (("Global mutex creation failure, %s\n",
 			acpi_format_exception (status)));
 		return_ACPI_STATUS (status);
 	}
@@ -92,7 +107,7 @@
 
 	status = acpi_ns_root_initialize ();
 	if (ACPI_FAILURE (status)) {
-		REPORT_ERROR (("Namespace initialization failure, %s\n",
+		ACPI_REPORT_ERROR (("Namespace initialization failure, %s\n",
 			acpi_format_exception (status)));
 		return_ACPI_STATUS (status);
 	}
@@ -100,7 +115,7 @@
 
 	/* If configured, initialize the AML debugger */
 
-	DEBUGGER_EXEC (acpi_db_initialize ());
+	ACPI_DEBUGGER_EXEC (status = acpi_db_initialize ());
 
 	return_ACPI_STATUS (status);
 }
@@ -108,7 +123,7 @@
 
 /*******************************************************************************
  *
- * FUNCTION:    Acpi_enable_subsystem
+ * FUNCTION:    acpi_enable_subsystem
  *
  * PARAMETERS:  Flags           - Init/enable Options
  *
@@ -121,37 +136,17 @@
 
 acpi_status
 acpi_enable_subsystem (
-	u32                     flags)
+	u32                             flags)
 {
-	acpi_status             status = AE_OK;
-
-
-	FUNCTION_TRACE ("Acpi_enable_subsystem");
-
+	acpi_status                     status = AE_OK;
 
-	/* Sanity check the FADT for valid values */
 
-	status = acpi_ut_validate_fadt ();
-	if (ACPI_FAILURE (status)) {
-		return_ACPI_STATUS (status);
-	}
+	ACPI_FUNCTION_TRACE ("acpi_enable_subsystem");
 
-	/*
-	 * Install the default Op_region handlers. These are
-	 * installed unless other handlers have already been
-	 * installed via the Install_address_space_handler interface
-	 */
-	if (!(flags & ACPI_NO_ADDRESS_SPACE_INIT)) {
-		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Installing default address space handlers\n"));
-
-		status = acpi_ev_install_default_address_space_handlers ();
-		if (ACPI_FAILURE (status)) {
-			return_ACPI_STATUS (status);
-		}
-	}
 
 	/*
 	 * We must initialize the hardware before we can enable ACPI.
+	 * The values from the FADT are validated here.
 	 */
 	if (!(flags & ACPI_NO_HARDWARE_INIT)) {
 		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Initializing ACPI hardware\n"));
@@ -163,21 +158,24 @@
 	}
 
 	/*
-	 * Enable ACPI on this platform
+	 * Enable ACPI mode
 	 */
 	if (!(flags & ACPI_NO_ACPI_ENABLE)) {
 		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Going into ACPI mode\n"));
 
+		acpi_gbl_original_mode = acpi_hw_get_mode();
+
 		status = acpi_enable ();
 		if (ACPI_FAILURE (status)) {
-			ACPI_DEBUG_PRINT ((ACPI_DB_WARN, "Acpi_enable failed.\n"));
+			ACPI_DEBUG_PRINT ((ACPI_DB_WARN, "acpi_enable failed.\n"));
 			return_ACPI_STATUS (status);
 		}
 	}
 
 	/*
-	 * Note:
-	 * We must have the hardware AND events initialized before we can execute
+	 * Initialize ACPI Event handling
+	 *
+	 * NOTE: We must have the hardware AND events initialized before we can execute
 	 * ANY control methods SAFELY.  Any control method can require ACPI hardware
 	 * support, so the hardware MUST be initialized before execution!
 	 */
@@ -190,25 +188,65 @@
 		}
 	}
 
+	/* Install the SCI handler, Global Lock handler, and GPE handlers */
+
+	if (!(flags & ACPI_NO_HANDLER_INIT)) {
+		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Installing SCI/GL/GPE handlers\n"));
+
+		status = acpi_ev_handler_initialize ();
+		if (ACPI_FAILURE (status)) {
+			return_ACPI_STATUS (status);
+		}
+	}
+
+	return_ACPI_STATUS (status);
+}
+
+/*******************************************************************************
+ *
+ * FUNCTION:    acpi_initialize_objects
+ *
+ * PARAMETERS:  Flags           - Init/enable Options
+ *
+ * RETURN:      Status
+ *
+ * DESCRIPTION: Completes namespace initialization by initializing device
+ *              objects and executing AML code for Regions, buffers, etc.
+ *
+ ******************************************************************************/
+
+acpi_status
+acpi_initialize_objects (
+	u32                             flags)
+{
+	acpi_status                     status = AE_OK;
+
+
+	ACPI_FUNCTION_TRACE ("acpi_initialize_objects");
+
 
 	/*
-	 * Initialize all device objects in the namespace
-	 * This runs the _STA and _INI methods.
+	 * Install the default op_region handlers. These are installed unless
+	 * other handlers have already been installed via the
+	 * install_address_space_handler interface.
+	 *
+	 * NOTE: This will cause _REG methods to be run.  Any objects accessed
+	 * by the _REG methods will be automatically initialized, even if they
+	 * contain executable AML (see call to acpi_ns_initialize_objects below).
 	 */
-	if (!(flags & ACPI_NO_DEVICE_INIT)) {
-		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Initializing ACPI Devices\n"));
+	if (!(flags & ACPI_NO_ADDRESS_SPACE_INIT)) {
+		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Installing default address space handlers\n"));
 
-		status = acpi_ns_initialize_devices ();
+		status = acpi_ev_init_address_spaces ();
 		if (ACPI_FAILURE (status)) {
 			return_ACPI_STATUS (status);
 		}
 	}
 
-
 	/*
 	 * Initialize the objects that remain uninitialized.  This
-	 * runs the executable AML that is part of the declaration of Op_regions
-	 * and Fields.
+	 * runs the executable AML that may be part of the declaration of these
+	 * objects: operation_regions, buffer_fields, Buffers, and Packages.
 	 */
 	if (!(flags & ACPI_NO_OBJECT_INIT)) {
 		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Initializing ACPI Objects\n"));
@@ -219,15 +257,34 @@
 		}
 	}
 
-	acpi_gbl_startup_flags |= ACPI_INITIALIZED_OK;
+	/*
+	 * Initialize all device objects in the namespace
+	 * This runs the _STA and _INI methods.
+	 */
+	if (!(flags & ACPI_NO_DEVICE_INIT)) {
+		ACPI_DEBUG_PRINT ((ACPI_DB_EXEC, "[Init] Initializing ACPI Devices\n"));
 
+		status = acpi_ns_initialize_devices ();
+		if (ACPI_FAILURE (status)) {
+			return_ACPI_STATUS (status);
+		}
+	}
+
+	/*
+	 * Empty the caches (delete the cached objects) on the assumption that
+	 * the table load filled them up more than they will be at runtime --
+	 * thus wasting non-paged memory.
+	 */
+	status = acpi_purge_cached_objects ();
+
+	acpi_gbl_startup_flags |= ACPI_INITIALIZED_OK;
 	return_ACPI_STATUS (status);
 }
 
 
 /*******************************************************************************
  *
- * FUNCTION:    Acpi_terminate
+ * FUNCTION:    acpi_terminate
  *
  * PARAMETERS:  None
  *
@@ -240,16 +297,15 @@
 acpi_status
 acpi_terminate (void)
 {
-	FUNCTION_TRACE ("Acpi_terminate");
+	acpi_status                 status;
 
 
-	/* Terminate the AML Debugger if present */
+	ACPI_FUNCTION_TRACE ("acpi_terminate");
 
-	DEBUGGER_EXEC(acpi_gbl_db_terminate_threads = TRUE);
 
-	/* TBD: [Investigate] This is no longer needed?*/
-/*    Acpi_ut_release_mutex (ACPI_MTX_DEBUG_CMD_READY); */
+	/* Terminate the AML Debugger if present */
 
+	ACPI_DEBUGGER_EXEC(acpi_gbl_db_terminate_threads = TRUE);
 
 	/* Shutdown and free all resources */
 
@@ -261,7 +317,7 @@
 	acpi_ut_mutex_terminate ();
 
 
-#ifdef ENABLE_DEBUGGER
+#ifdef ACPI_DEBUGGER
 
 	/* Shut down the debugger */
 
@@ -270,16 +326,14 @@
 
 	/* Now we can shutdown the OS-dependent layer */
 
-	acpi_os_terminate ();
-
-
-	return_ACPI_STATUS (AE_OK);
+	status = acpi_os_terminate ();
+	return_ACPI_STATUS (status);
 }
 
 
 /*****************************************************************************
  *
- * FUNCTION:    Acpi_subsystem_status
+ * FUNCTION:    acpi_subsystem_status
  *
  * PARAMETERS:  None
  *
@@ -305,65 +359,62 @@
 
 /******************************************************************************
  *
- * FUNCTION:    Acpi_get_system_info
+ * FUNCTION:    acpi_get_system_info
  *
- * PARAMETERS:  Out_buffer      - a pointer to a buffer to receive the
+ * PARAMETERS:  out_buffer      - a pointer to a buffer to receive the
  *                                resources for the device
- *              Buffer_length   - the number of bytes available in the buffer
+ *              buffer_length   - the number of bytes available in the buffer
  *
  * RETURN:      Status          - the status of the call
  *
  * DESCRIPTION: This function is called to get information about the current
  *              state of the ACPI subsystem.  It will return system information
- *              in the Out_buffer.
+ *              in the out_buffer.
  *
  *              If the function fails an appropriate status will be returned
- *              and the value of Out_buffer is undefined.
+ *              and the value of out_buffer is undefined.
  *
  ******************************************************************************/
 
 acpi_status
 acpi_get_system_info (
-	acpi_buffer             *out_buffer)
+	struct acpi_buffer              *out_buffer)
 {
-	acpi_system_info        *info_ptr;
-	u32                     i;
+	struct acpi_system_info         *info_ptr;
+	u32                             i;
+	acpi_status                     status;
 
 
-	FUNCTION_TRACE ("Acpi_get_system_info");
+	ACPI_FUNCTION_TRACE ("acpi_get_system_info");
 
 
-	/*
-	 *  Must have a valid buffer
-	 */
-	if ((!out_buffer)         ||
-		(!out_buffer->pointer)) {
-		return_ACPI_STATUS (AE_BAD_PARAMETER);
+	/* Parameter validation */
+
+	status = acpi_ut_validate_buffer (out_buffer);
+	if (ACPI_FAILURE (status)) {
+		return_ACPI_STATUS (status);
 	}
 
-	if (out_buffer->length < sizeof (acpi_system_info)) {
-		/*
-		 *  Caller's buffer is too small
-		 */
-		out_buffer->length = sizeof (acpi_system_info);
+	/* Validate/Allocate/Clear caller buffer */
 
-		return_ACPI_STATUS (AE_BUFFER_OVERFLOW);
+	status = acpi_ut_initialize_buffer (out_buffer, sizeof (struct acpi_system_info));
+	if (ACPI_FAILURE (status)) {
+		return_ACPI_STATUS (status);
 	}
 
-
 	/*
-	 *  Set return length and get data
+	 * Populate the return buffer
 	 */
-	out_buffer->length = sizeof (acpi_system_info);
-	info_ptr = (acpi_system_info *) out_buffer->pointer;
+	info_ptr = (struct acpi_system_info *) out_buffer->pointer;
 
 	info_ptr->acpi_ca_version   = ACPI_CA_VERSION;
 
 	/* System flags (ACPI capabilities) */
 
-	info_ptr->flags             = acpi_gbl_system_flags;
+	info_ptr->flags             = ACPI_SYS_MODE_ACPI;
 
 	/* Timer resolution - 24 or 32 bits  */
+
 	if (!acpi_gbl_FADT) {
 		info_ptr->timer_resolution = 0;
 	}
@@ -386,12 +437,70 @@
 
 	/* Current status of the ACPI tables, per table type */
 
-	info_ptr->num_table_types = NUM_ACPI_TABLES;
-	for (i = 0; i < NUM_ACPI_TABLES; i++) {
-		info_ptr->table_info[i].count = acpi_gbl_acpi_tables[i].count;
+	info_ptr->num_table_types = NUM_ACPI_TABLE_TYPES;
+	for (i = 0; i < NUM_ACPI_TABLE_TYPES; i++) {
+		info_ptr->table_info[i].count = acpi_gbl_table_lists[i].count;
 	}
 
 	return_ACPI_STATUS (AE_OK);
 }
 
 
+/*****************************************************************************
+ *
+ * FUNCTION:    acpi_install_initialization_handler
+ *
+ * PARAMETERS:  Handler             - Callback procedure
+ *
+ * RETURN:      Status
+ *
+ * DESCRIPTION: Install an initialization handler
+ *
+ * TBD: When a second function is added, must save the Function also.
+ *
+ ****************************************************************************/
+
+acpi_status
+acpi_install_initialization_handler (
+	acpi_init_handler               handler,
+	u32                             function)
+{
+
+	if (!handler) {
+		return (AE_BAD_PARAMETER);
+	}
+
+	if (acpi_gbl_init_handler) {
+		return (AE_ALREADY_EXISTS);
+	}
+
+	acpi_gbl_init_handler = handler;
+	return AE_OK;
+}
+
+
+/*****************************************************************************
+ *
+ * FUNCTION:    acpi_purge_cached_objects
+ *
+ * PARAMETERS:  None
+ *
+ * RETURN:      Status
+ *
+ * DESCRIPTION: Empty all caches (delete the cached objects)
+ *
+ ****************************************************************************/
+
+acpi_status
+acpi_purge_cached_objects (void)
+{
+	ACPI_FUNCTION_TRACE ("acpi_purge_cached_objects");
+
+
+	acpi_ut_delete_generic_state_cache ();
+	acpi_ut_delete_object_cache ();
+	acpi_ds_delete_walk_state_cache ();
+	acpi_ps_delete_parse_cache ();
+
+	return_ACPI_STATUS (AE_OK);
+}
Index: drivers/at91/i2c/at91_i2c.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/i2c/at91_i2c.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/i2c/at91_i2c.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/i2c/at91_i2c.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -46,70 +46,16 @@
 static struct at91_i2c_local *at91_i2c_device;
 
 /*
- * SMBUS-type transfer entrypoint
+ * Poll the i2c status register until the specified bit is set.
+ * Returns 0 if timed out (100 msec)
  */
-static s32 at91_smbus_xfer(struct i2c_adapter *adap,
-		u16 addr,
-		unsigned short flags,
-		char read_write,
-		u8 command, int size, union i2c_smbus_data *data)
-{
-#if 0
-	struct at91_i2c_local *device = (struct at91_i2c_local *) adap->data;
-	int len;
-	u8 *buffer;
-	u16 cur_word;
-	int rc = 0;
-
-	/* Prepare datas & select mode */
-	switch (size) {
-	case I2C_SMBUS_QUICK:
-		len = 0;
-		buffer = NULL;
-		break;
-	case I2C_SMBUS_BYTE:
-		len = 1;
-		buffer = &data->byte;
-		break;
-	case I2C_SMBUS_BYTE_DATA:
-		len = 1;
-		buffer = &data->byte;
-		break;
-	case I2C_SMBUS_WORD_DATA:
-		len = 2;
-		cur_word = cpu_to_le16(data->word);
-		buffer = (u8 *) & cur_word;
-		break;
-	case I2C_SMBUS_BLOCK_DATA:
-		len = data->block[0];
-		buffer = &data->block[1];
-		break;
-	default:
-		return -1;
-	}
-
-	/* Original driver had this limitation */
-	if (len > 32)
-		len = 32;
-
-	DBG("chan: %d, addr: 0x%x, transfer len: %d, read: %d\n",
-	    device->chan_no, addr, len, read_write == I2C_SMBUS_READ);
-
-	/* Set up address and r/w bit */
-	write_reg(reg_addr, (addr << 1) | ((read_write == I2C_SMBUS_READ) ? 0x01 : 0x00));
-
-	/* Set up the sub address */
+static short at91_poll_status(AT91PS_TWI twi, unsigned long bit) {
+	int loop_cntr = 10000;
+	do {
+		udelay(10);
+	} while (!(twi->TWI_SR & bit) && (--loop_cntr > 0));
 
-	/* Start sending address & enable interrupt */
-	write_reg(reg_control, read_reg(reg_control) | KW_I2C_CTL_XADDR);
-	write_reg(reg_ier, KW_I2C_IRQ_MASK);
-
-	DBG("transfer done\n");
-
-	if (size == I2C_SMBUS_WORD_DATA && read_write == I2C_SMBUS_READ)
-		data->word = le16_to_cpu(cur_word);
-#endif
-	return 0;
+	return (loop_cntr > 0);
 }
 
 /*
@@ -121,11 +67,17 @@
 	AT91PS_TWI twi = (AT91PS_TWI) device->base_addr;
 
 	struct i2c_msg *pmsg;
-	int completed = 0, length;
+	int length;
 	unsigned char *buf;
 
+	/*
+	 * i2c_smbus_xfer_emulated() in drivers/i2c/i2c-core.c states:
+	 * "... In the case of writing, we need to use only one message;
+	 * when reading, we need two..."
+	 */
+
 	pmsg = msgs;		/* look at 1st message, it contains the address/command */
-	if (num == 2 && pmsg->len >= 1 && pmsg->len <= 3) {
+	if (num >= 1 && num <= 2) {
 		DBG("xfer: doing %s %d bytes to 0x%02x - %d messages\n",
 		    pmsg->flags & I2C_M_RD ? "read" : "write",
 		    pmsg->len, pmsg->buf[0], num);
@@ -142,7 +94,10 @@
 		else			/* must be 3 */
 			twi->TWI_IADR =  pmsg->buf[0] << 16 | pmsg->buf[1] << 8 | pmsg->buf[2];
 
-		pmsg++;		/* go to real message */
+		/* 1st message contains the address/command */
+		if (num > 1)
+			pmsg++;		/* go to real message */
+
 		length = pmsg->len;
 		buf = pmsg->buf;
 		if (length && buf) {	/* sanity check */
@@ -152,33 +107,41 @@
 					if (!length)
 						twi->TWI_CR = AT91C_TWI_STOP;
 					/* Wait until transfer is finished */
-					do
-						udelay(10);
-					while (!(twi->TWI_SR & AT91C_TWI_RXRDY));
+					if (!at91_poll_status(twi, AT91C_TWI_RXRDY)) {
+						printk(KERN_ERR "at91_i2c: timeout 1\n");
+						return 0;
+					}
 					*buf++ = twi->TWI_RHR;
 				}
-				do {
-					udelay(10);
-				} while (!(twi->TWI_SR & AT91C_TWI_TXCOMP));
+				if (!at91_poll_status(twi, AT91C_TWI_TXCOMP)) {
+					printk(KERN_ERR "at91_i2c: timeout 2\n");
+					return 0;
+				}
 			} else {
 				twi->TWI_CR = AT91C_TWI_START;
 				while (length--) {
 					twi->TWI_THR = *buf++;
 					if (!length)
 						twi->TWI_CR = AT91C_TWI_STOP;
-					do {
-						udelay(10);
-					} while (!(twi->TWI_SR & AT91C_TWI_TXRDY));
+					if (!at91_poll_status(twi, AT91C_TWI_TXRDY)) {
+						printk(KERN_ERR "at91_i2c: timeout 3\n");
+						return 0;
+					}
 				}
 				/* Wait until transfer is finished */
-				do {
-					udelay(10);
-				} while (!(twi->TWI_SR & AT91C_TWI_TXCOMP));
+				if (!at91_poll_status(twi, AT91C_TWI_TXCOMP)) {
+					printk(KERN_ERR "at91_i2c: timeout 4\n");
+					return 0;
+				}
 			}
 		}
+		DBG("transfer complete\n");
+		return num;
+	}
+	else {
+		printk(KERN_ERR "at91_i2c: unexpected number of messages: %d\n", num);
+		return 0;
 	}
-	DBG("transfer done\n");
-	return completed++;
 }
 
 /*
@@ -197,7 +160,6 @@
 static void at91_inc(struct i2c_adapter *adapter)
 {
 	MOD_INC_USE_COUNT;
-	AT91_SYS->PMC_PCER = 1 << AT91C_ID_TWI;	/* enable peripheral clock */
 }
 
 /*
@@ -205,7 +167,6 @@
  */
 static void at91_dec(struct i2c_adapter *adapter)
 {
-	AT91_SYS->PMC_PCDR = 1 << AT91C_ID_TWI;	/* disable peripheral clock */
 	MOD_DEC_USE_COUNT;
 }
 
@@ -213,7 +174,6 @@
 static struct i2c_algorithm at91_algorithm = {
 	name:"at91 i2c",
 	id:I2C_ALGO_SMBUS,
-	smbus_xfer:at91_smbus_xfer,
 	master_xfer:at91_xfer,
 	functionality:at91_func,
 };
@@ -228,6 +188,7 @@
 	int rc;
 
 	AT91_CfgPIO_TWI();
+	AT91_SYS->PMC_PCER = 1 << AT91C_ID_TWI;		/* enable peripheral clock */
 
 	twi->TWI_IDR = 0x3ff;				/* Disable all interrupts */
 	twi->TWI_CR = AT91C_TWI_SWRST;			/* Reset peripheral */
@@ -277,6 +238,8 @@
 	rc = i2c_del_adapter(&device->adapter);
 	device->adapter.data = NULL;
 	kfree(device);
+	
+	AT91_SYS->PMC_PCDR = 1 << AT91C_ID_TWI;		/* disable peripheral clock */
 
 	/* We aren't that prepared to deal with this... */
 	if (rc)
Index: drivers/at91/i2c/at91_i2c.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/i2c/at91_i2c.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/i2c/at91_i2c.h	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/i2c/at91_i2c.h	4 Aug 2004 01:28:37 -0000	1.2
@@ -23,7 +23,7 @@
 
 #define AT91C_TWI_CLOCK		100000
 #define AT91C_TWI_SCLOCK	(10 * AT91C_MASTER_CLOCK / AT91C_TWI_CLOCK)
-#define AT91C_TWI_CKDIV1	(1 << 16)	/* TWI clock divider */
+#define AT91C_TWI_CKDIV1	(2 << 16)	/* TWI clock divider.  NOTE: see Errata #22 */
 
 #if (AT91C_TWI_SCLOCK % 10) >= 5
 #define AT91C_TWI_CLDIV2 ((AT91C_TWI_SCLOCK / 10) - 5)
Index: drivers/at91/mtd/at91_dataflash.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/mtd/at91_dataflash.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/mtd/at91_dataflash.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/mtd/at91_dataflash.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -135,7 +135,7 @@
 /* ......................................................................... */
 
 /*
- * Erase a block of flash.
+ * Erase blocks of flash.
  */
 int at91_dataflash_erase(struct mtd_info *mtd, struct erase_info *instr)
 {
@@ -150,7 +150,7 @@
 	/* Sanity checks */
 	if (instr->addr + instr->len > mtd->size)
 		return -EINVAL;
-	if ((instr->len != mtd->erasesize) || (instr->len != priv->page_size))
+	if ((instr->len % mtd->erasesize != 0) || (instr->len % priv->page_size != 0))
 		return -EINVAL;
 	if ((instr->addr % priv->page_size) != 0)
 		return -EINVAL;
@@ -159,23 +159,28 @@
 	if (!command)
 		return -ENOMEM;
 
-	/* Calculate flash page address */
-	pageaddr = (instr->addr / priv->page_size) << priv->page_offset;
-
-	command[0] = OP_ERASE_PAGE;
-	command[1] = (pageaddr & 0x00FF0000) >> 16;
-	command[2] = (pageaddr & 0x0000FF00) >> 8;
-	command[3] = 0;
+	while (instr->len > 0) {
+		/* Calculate flash page address */
+		pageaddr = (instr->addr / priv->page_size) << priv->page_offset;
+
+		command[0] = OP_ERASE_PAGE;
+		command[1] = (pageaddr & 0x00FF0000) >> 16;
+		command[2] = (pageaddr & 0x0000FF00) >> 8;
+		command[3] = 0;
 #ifdef DEBUG_DATAFLASH
-	printk("ERASE: (%x) %x %x %x [%i]\n", command[0], command[1], command[2], command[3], pageaddr);
+		printk("ERASE: (%x) %x %x %x [%i]\n", command[0], command[1], command[2], command[3], pageaddr);
 #endif
 
-	/* Send command to SPI device */
-	spi_access_bus(priv->spi);
-	do_spi_transfer(1, command, 4, command, 4, NULL, 0, NULL, 0);
+		/* Send command to SPI device */
+		spi_access_bus(priv->spi);
+		do_spi_transfer(1, command, 4, command, 4, NULL, 0, NULL, 0);
 
-	at91_dataflash_waitready();	/* poll status until ready */
-	spi_release_bus(priv->spi);
+		at91_dataflash_waitready();		/* poll status until ready */
+		spi_release_bus(priv->spi);
+
+		instr->addr += priv->page_size;		/* next page */
+		instr->len -= priv->page_size;
+	}
 
 	kfree(command);
 
@@ -249,10 +254,11 @@
 	struct dataflash_local *priv = (struct dataflash_local *) mtd->priv;
 	unsigned int pageaddr, addr, offset, writelen;
 	size_t remaining;
-	char *writebuf;
+	u_char *writebuf;
 	unsigned short status;
 	int res = 0;
 	char* command;
+	char* tmpbuf = NULL;
 
 #ifdef DEBUG_DATAFLASH
 	printk("dataflash_write: %lli .. %lli\n", to, to+len);
@@ -279,6 +285,13 @@
 	writebuf = buf;
 	remaining = len;
 
+	/* Allocate temporary buffer */
+	tmpbuf = kmalloc(priv->page_size, GFP_KERNEL);
+	if (!tmpbuf) {
+		kfree(command);
+		return -ENOMEM;
+	}
+
 	/* Gain access to the SPI bus */
 	spi_access_bus(priv->spi);
 
@@ -310,7 +323,7 @@
 #ifdef DEBUG_DATAFLASH
 		printk("PROGRAM: (%x) %x %x %x\n", command[0], command[1], command[2], command[3]);
 #endif
-		do_spi_transfer(2, command, 4, command, 4, writebuf, writelen, writebuf, writelen);
+		do_spi_transfer(2, command, 4, command, 4, writebuf, writelen, tmpbuf, writelen);
 		at91_dataflash_waitready();
 
 		/* (3) Compare to Buffer1 */
@@ -348,6 +361,7 @@
 	/* Release SPI bus */
 	spi_release_bus(priv->spi);
 
+	kfree(tmpbuf);
 	kfree(command);
 	return res;
 }
Index: drivers/at91/mtd/at91_nand.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/mtd/at91_nand.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/mtd/at91_nand.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/mtd/at91_nand.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -31,7 +31,7 @@
  * MTD structure for AT91 board
  */
 static struct mtd_info *at91_mtd = NULL;
-static struct nand_chip *my_nand_chip;
+static struct nand_chip *my_nand_chip = NULL;
 
 static int at91_fio_base;
 
@@ -79,7 +79,7 @@
 /*
  * Hardware specific access to control-lines
  */
-void at91_hwcontrol(int cmd)
+static void at91_hwcontrol(int cmd)
 {
 	struct nand_chip *my_nand = my_nand_chip;
 	switch(cmd)
@@ -168,14 +168,14 @@
 /*
  * Read the Device Ready pin.
  */
-int at91_device_ready(void)
+static int at91_device_ready(void)
 {
 	return AT91_PIO_SmartMedia_RDY();
 }
 /*
  * Main initialization routine
  */
-int __init at91_init (void)
+static int __init at91_init (void)
 {
 	struct nand_chip *my_nand;
 	int err = 0;
@@ -211,7 +211,8 @@
 	my_nand->IO_ADDR_W = at91_fio_base;
 	my_nand->hwcontrol = at91_hwcontrol;
 	my_nand->dev_ready = at91_device_ready;
-	my_nand->cmdfunc = at91_nand_command; /* we need our own */
+	my_nand->cmdfunc = at91_nand_command;	/* we need our own */
+	my_nand->eccmode = NAND_ECC_SOFT;	/* enable ECC */
 	/* 20 us command delay time */
 	my_nand->chip_delay = 20;
 
@@ -222,11 +223,11 @@
 	   tDH Data Hold Time 20 - ns
 	   tALS ALE Set up Time 20 - ns
 	   16ns at 60 MHz ~= 3  */
-#define AT91C_SM_ID_RWH	(5 << 28)		/* debug only orig = 5 */
+#define AT91C_SM_ID_RWH	(5 << 28)		/* orig = 5 */
 #define AT91C_SM_RWH	(1 << 28)		/* orig = 1 */
 #define AT91C_SM_RWS	(0 << 24)		/* orig = 0 */
 #define AT91C_SM_TDF	(1 << 8)		/* orig = 1 */
-#define AT91C_SM_NWS	(3)			/* orig = 3 */
+#define AT91C_SM_NWS	(5)			/* orig = 3 */
 	AT91_SYS->EBI_SMC2_CSR[3] = ( AT91C_SM_RWH | AT91C_SM_RWS |
 					 AT91C_SMC2_ACSS_STANDARD |
 					 AT91C_SMC2_DBW_8 | AT91C_SM_TDF |
